/** FunnyMu: portable Coleco emulator **************************/
/**                                                         **/
/**                          funnymu.c                      **/
/**                                                         **/
/** This file contains generic main() procedure statrting   **/
/** the emulation.                                          **/
/**                                                         **/
/** Copyright (C) Paul Hayter 2001                          **/
/**     Heavily based on ColEm by Marat Fayzullin           **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994-1998                 **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/
#include "sdl/SDL.h"
#include "funny.h"
#include "Help.h"
#include "filebrowser.h"
#include <gccore.h>
#include <ogcsys.h>
#include <sdcard/wiisd_io.h>
#include "fat.h"
#include <dirent.h>
#include <sys/stat.h>
#include <wiiuse/wpad.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

char *Options[]=
{ 
  "verbose","hperiod","vperiod","uperiod","help",
  "autoa","noautoa","autob","noautob","logsnd",
  "trap","sound","nosound","shm","noshm","saver",
  "nosaver","vsync","novsync",0
};

extern int   UseSound;   /* Sound mode (#ifdef SOUND)           */
extern int   UseSHM;     /* Use SHM X extension (#ifdef MITSHM) */
extern int   SaveCPU;    /* Pause when inactive (#ifdef UNIX)   */
extern int   SyncScreen; /* Sync screen updates (#ifdef MSDOS)  */

extern void WII_VideoStart();
extern void WII_VideoStop();
extern int PauseAudio(int Switch);
extern void ResetAudio();

char * rom_filename;
int mode=0;

void menu_fic()
{
	iprintf(" B -pour relire --R Retour---\n");
}

void menu_rep()
{
	iprintf(" --- A -suite- R -Retour --- \n --- X -sous rep- ---\n");
}
void menu_finrep()
{
	iprintf(" --- R -Retour- X -sous rep ---\n");
}


static char *replace_str(char *str, char *orig, char *rep)
{
  static char buffer[4096];
  char *p;

  if(!(p = strstr(str, orig)))  // Is 'orig' even in 'str'?
    return str;

  strncpy(buffer, str, p-str); // Copy characters from 'str' start to 'orig' st$
  buffer[p-str] = '\0';

  sprintf(buffer+(p-str), "%s%s", rep, p+strlen(orig));

  return buffer;
}


const char *newStr(const char *string)
{
    return string+1;
}

/** main() ***************************************************/
/** This is a main() function used in Unix and MSDOS ports. **/
/** It parses command line arguments, sets emulation        **/
/** parameters, and passes control to the emulation itself. **/
/*************************************************************/
#undef main
//int main(int argc,char *argv[]) {
int SDL_main(int argc,char *argv[]) {

fatInitDefault();
fatUnmount("sd:/");
__io_wiisd.shutdown();
fatMountSimple("sd", &__io_wiisd);

char *CartName="pff";
//sprintf(CartName, "pff");
int N,J,I;

#ifdef DEBUG
  CPU.Trap=0xFFFF;CPU.Trace=0;
#endif

#ifdef MSDOS
  Verbose=0;
#else
  Verbose=5;
#endif

char filename[255];
rom_filename=filename;
sprintf(rom_filename, "/apps/funny/roms/");
bool gLoop = true;
int frame = 0;
char *nene;

	if(FileBrowser(rom_filename) != 0)
	{
	printf("Error ...");
	}
	nene =  newStr(rom_filename);
	//printf("\n Loading %s ...\n", rom_filename);
	//printf("\nnene   %s\n", nene);
	//SDL_Delay(4000);

	  if(!InitMachine())
	{ 
		return(1);
	}

    // StartFunny(CartName);
    StartFunny(nene);
    SDL_Quit();
    TrashFunny();
    TrashMachine();
    return(0);
}
