#include "sdl/SDL.h"   /* All SDL App's need this */
#include <sdl/SDL_mixer.h>
#include <sdl/SDL_image.h>
#include <sdl/SDL_ttf.h>
#include <sdl/SDL_gfxPrimitives.h>

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include "funny.h"
#include "funnysdl.h"

/* Globals */
#define PLAYBUF_SIZE 1024
static Uint8 playbuf[PLAYBUF_SIZE];
static volatile int snd_read = 0;
static SDL_AudioSpec spec;

int SaveCPU  = 1;               /* 1 = freeze when focus out */
int UseSHM   = 1;               /* 1 = use MITSHM            */
int UseSound = 1;               /* 1 = use sound             */

SDL_Surface *sdl_screen;
Uint32  sdl_colours[16];
char sdl_title[]="FunnyMu v0.41";

extern int   mode;
int bigfuk=0;
extern char * rom_filename;
extern void WII_VideoStart();
extern void WII_VideoStop();
//extern int PauseAudio();
extern void ResetAudio();

#define WIDTH  256
#define HEIGHT 208

static SDL_Joystick *sdlJoystick[6] =   /* SDL's joystick structures */
{
	NULL, NULL, NULL, NULL, NULL, NULL
};

void sdl_setpalette(void) {
  /* struct { Uint8 R,G,B; } Palette[16] =
   {
     {0x00,0x00,0x00},{0x00,0x00,0x00},{0x20,0xC0,0x20},{0x60,0xE0,0x60},
     {0x20,0x20,0xE0},{0x40,0x60,0xE0},{0xA0,0x20,0x20},{0x40,0xC0,0xE0},
     {0xE0,0x20,0x20},{0xE0,0x60,0x60},{0xC0,0xC0,0x20},{0xC0,0xC0,0x80},
     {0x20,0x80,0x20},{0xC0,0x40,0xA0},{0xA0,0xA0,0xA0},{0xE0,0xE0,0xE0}
   };*/

struct { Uint8 R,G,B; } Palette[16] = {
    /* palette from MAME by S. Young */
    {0x00, 0x00, 0x00},	// 0 transparent (should be set on VDP as bg color)
    {0x00, 0x00, 0x00},	// 1 black
    {0x21, 0xc8, 0x42},	// 2 medium green
    {0x5e, 0xdc, 0x78}, // 3 light green
    {0x54, 0x55, 0xed},	// 4 dark blue
    {0x7d, 0x76, 0xfc},	// 5 light blue
    {0xd4, 0x52, 0x4d},	// 6 dark red
    {0x42, 0xeb, 0xf5},	// 7 cyan
    {0xfc, 0x55, 0x54},	// 8 medium red
    {0xff, 0x79, 0x78},	// 9 light red
    {0xd4, 0xC1, 0x54},	// A dark yellow
    {0xe6, 0xCe, 0x80},	// B light yellow
    {0x21, 0xb0, 0x3b},	// C dark green
    {0xc9, 0x5b, 0xba},	// D magenta
    {0xcc, 0xcc, 0xcc},	// E gray
    {0xff, 0xff, 0xff}	// F white
	};
   int i;

   printf("set_palette\n");
   for (i=0;i<16;i++) {
      sdl_colours[i] = SDL_MapRGB(sdl_screen->format, 
        Palette[i].R, Palette[i].G, Palette[i].B);
      sdl_colours[i]+=sdl_colours[i]<<16;
   }
}

static void _sdl_snd_callback(void *udata, Uint8 *stream, int len)
{
  int i;
  for(i = 0; i < len; ++i)
    {
      if(snd_read == PLAYBUF_SIZE) {
         SN76496Update(0,playbuf,PLAYBUF_SIZE/2);
         snd_read=0;
      }
      stream[i] = (playbuf[snd_read++] -0x6000)>>1;
    }
}

int sound_init(void) {

   SDL_AudioSpec wanted;

   wanted.freq = 22050;
   wanted.format = AUDIO_S16;
   wanted.channels = 1;
   wanted.samples = 256;
   wanted.callback = _sdl_snd_callback;
   wanted.userdata = NULL;

   if(SDL_OpenAudio(&wanted, &spec) < 0)
   {
      fprintf(stderr, "sdl: Couldn't open audio: %s!\n", SDL_GetError());
	  SDL_Delay(2000);
      return 0;
   } else {
      printf("sdl audio opened\n");
   }

   SN76496Init(0,VDP_CLOCK/15,0,spec.freq);
   SDL_PauseAudio(0);
   return(0);

}


int init_sdl(void) {
    int x;
    Uint32 y;
    Uint8  *buffer;
    
    printf("Initializing SDL.\n");
    
    /* Initialize defaults, Video and Audio */
    if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)==-1)) { 
        printf("Could not initialize SDL: %s.\n", SDL_GetError());
        exit(-1);
    }
    atexit(SDL_Quit);
    sound_init();
	SDL_Init( SDL_INIT_JOYSTICK);

	int i, nPadsConnected;
	/* Scan the joysticks */
	nPadsConnected = SDL_NumJoysticks();
	for (i = 0; i < nPadsConnected && i < 6; i++)
	{
		/* Open the joysticks for use */
		sdlJoystick[i] = SDL_JoystickOpen(i);
		/* joystick connected? */
		if (sdlJoystick[i] != NULL)		
		printf( "Joystick %d connected!",SDL_JoystickName(i));		
	}

	sdl_screen = SDL_SetVideoMode(512, 420, 16, SDL_FULLSCREEN);
    sdl_setpalette();
    //SDL_WM_SetCaption(sdl_title,sdl_title);
	SDL_ShowCursor(SDL_DISABLE);

    return(0);
}

Uint32 sdl_getticks(void) {
   return(SDL_GetTicks());
}


/** This function is called on signals ***********************/
static void OnBreak(int Arg) { ExitNow=1;signal(Arg,OnBreak); }

/** InitMachine() ********************************************/
/** Allocate resources needed by Unix/X-dependent code.     **/
/*************************************************************/
int InitMachine(void)
{
  init_sdl();
  /* Catch all signals */
#ifndef WIN32
  signal(SIGHUP,OnBreak);signal(SIGINT,OnBreak);
  signal(SIGQUIT,OnBreak);signal(SIGTERM,OnBreak);
#endif
  return(1);
}

/** TrashMachine() *******************************************/
/** Deallocate all resources taken by InitMachine().        **/
/*************************************************************/
void TrashMachine(void)
{
  unsigned long L;
  int J;

  if(Verbose) printf("Shutting down...\n");
SDL_Delay(1000);

}

void Joysticks(void)
{
  SDL_Event sdl_event;

  if(SDL_PollEvent(&sdl_event))
  {
    if(sdl_event.type==SDL_KEYDOWN) {
      switch(sdl_event.key.keysym.sym)
      {
        case SDLK_F2:  LogSnd=!LogSnd;break;
        case SDLK_ESCAPE: Reset6502(&CPU); break;

        case SDLK_F12: ExitNow=1;break;
#ifdef DEBUG
        case SDLK_F1:  CPU.Trace=!CPU.Trace;break;
#endif

        case SDLK_z: KEYTBL[13]&=0xf5; break;
        case SDLK_a: KEYTBL[13]&=0xee; break;
        case SDLK_q: KEYTBL[13]&=0xe7; break;
        case SDLK_2: KEYTBL[13]&=0xcf; break;
        case SDLK_x: KEYTBL[13]&=0xed; break;
        case SDLK_s: KEYTBL[13]&=0xde; break;
        case SDLK_w: KEYTBL[13]&=0xf3; break;
        case SDLK_3: KEYTBL[13]&=0x9f; break;
        case SDLK_c: KEYTBL[13]&=0xdd; break;
        case SDLK_d: KEYTBL[13]&=0xbe; break;
        case SDLK_e: KEYTBL[13]&=0xeb; break;
        case SDLK_4: KEYTBL[13]&=0xd7; break;
        case SDLK_v: KEYTBL[13]&=0xbd; break;
        case SDLK_f: KEYTBL[13]&=0xfc; break;
        case SDLK_r: KEYTBL[13]&=0xdb; break;
        case SDLK_5: KEYTBL[13]&=0xb7; break;
        case SDLK_b: KEYTBL[13]&=0xf9; break;
        case SDLK_g: KEYTBL[13]&=0xfa; break;
        case SDLK_t: KEYTBL[13]&=0xbb; break;
        case SDLK_6: KEYTBL[13]&=0xaf; break;
        case SDLK_1: KEYTBL[14]&=0xf3; break;
        case SDLK_BACKSPACE: KEYTBL[13]&=0xf6; break;

        case SDLK_LCTRL:  KEYTBL[7]&=0x7f; break;
        case SDLK_LSHIFT: KEYTBL[13]&=0x7f; break;
        case SDLK_RSHIFT: KEYTBL[14]&=0x7f; break;
        case SDLK_TAB: KEYTBL[11]&=0x7f; break;

        case SDLK_COLON: KEYTBL[7]&=0xf5; break;
        case SDLK_p: KEYTBL[7]&=0xee; break;
        case SDLK_SEMICOLON: KEYTBL[7]&=0xe7; break;
        case SDLK_SLASH: KEYTBL[7]&=0xcf; break;
        case SDLK_0: KEYTBL[7]&=0xed; break;
        case SDLK_o: KEYTBL[7]&=0xde; break;
        case SDLK_l: KEYTBL[7]&=0xf3; break;
        case SDLK_PERIOD: KEYTBL[7]&=0x9f; break;
        case SDLK_9: KEYTBL[7]&=0xdd; break;
        case SDLK_i: KEYTBL[7]&=0xbe; break;
        case SDLK_k: KEYTBL[7]&=0xeb; break;
        case SDLK_COMMA: KEYTBL[7]&=0xd7; break;
        case SDLK_8: KEYTBL[7]&=0xbd; break;
        case SDLK_u: KEYTBL[7]&=0xfc; break;
        case SDLK_j: KEYTBL[7]&=0xdb; break;
        case SDLK_m: KEYTBL[7]&=0xb7; break;
        case SDLK_7: KEYTBL[7]&=0xf9; break;
        case SDLK_y: KEYTBL[7]&=0xfa; break;
        case SDLK_h: KEYTBL[7]&=0xbb; break;
        case SDLK_n: KEYTBL[7]&=0xaf; break;
        case SDLK_RETURN: KEYTBL[7]&=0xf6; break;
        case SDLK_SPACE: KEYTBL[11]&=0xf3; break;

        case SDLK_DOWN:   KEYTBL[14]&=0xfd;break;
        case SDLK_UP:     KEYTBL[14]&=0xf7;break;
        case SDLK_LEFT:   KEYTBL[14]&=0xdf;break;
        case SDLK_RIGHT:  KEYTBL[14]&=0xfb;break;


      }
    }
    if (sdl_event.type==SDL_KEYUP) {
      switch(sdl_event.key.keysym.sym)
      {
        case SDLK_z: KEYTBL[13]|=0x0a; break;
        case SDLK_a: KEYTBL[13]|=0x11; break;
        case SDLK_q: KEYTBL[13]|=0x18; break;
        case SDLK_2: KEYTBL[13]|=0x30; break;
        case SDLK_x: KEYTBL[13]|=0x12; break;
        case SDLK_s: KEYTBL[13]|=0x21; break;
        case SDLK_w: KEYTBL[13]|=0x0c; break;
        case SDLK_3: KEYTBL[13]|=0x60; break;
        case SDLK_c: KEYTBL[13]|=0x22; break;
        case SDLK_d: KEYTBL[13]|=0x41; break;
        case SDLK_e: KEYTBL[13]|=0x14; break;
        case SDLK_4: KEYTBL[13]|=0x28; break;
        case SDLK_v: KEYTBL[13]|=0x42; break;
        case SDLK_f: KEYTBL[13]|=0x03; break;
        case SDLK_r: KEYTBL[13]|=0x24; break;
        case SDLK_5: KEYTBL[13]|=0x48; break;
        case SDLK_b: KEYTBL[13]|=0x06; break;
        case SDLK_g: KEYTBL[13]|=0x05; break;
        case SDLK_t: KEYTBL[13]|=0x44; break;
        case SDLK_6: KEYTBL[13]|=0x50; break;
        case SDLK_1: KEYTBL[14]|=0x0c; break;
        case SDLK_BACKSPACE: KEYTBL[13]|=0x09; break;

        case SDLK_COLON: KEYTBL[7]|=0x0a; break;
        case SDLK_p: KEYTBL[7]|=0x11; break;
        case SDLK_SEMICOLON: KEYTBL[7]|=0x18; break;
        case SDLK_SLASH: KEYTBL[7]|=0x30; break;
        case SDLK_0: KEYTBL[7]|=0x12; break;
        case SDLK_o: KEYTBL[7]|=0x21; break;
        case SDLK_l: KEYTBL[7]|=0x0c; break;
        case SDLK_PERIOD: KEYTBL[7]|=0x60; break;
        case SDLK_9: KEYTBL[7]|=0x22; break;
        case SDLK_i: KEYTBL[7]|=0x41; break;
        case SDLK_k: KEYTBL[7]|=0x14; break;
        case SDLK_COMMA: KEYTBL[7]|=0x28; break;
        case SDLK_8: KEYTBL[7]|=0x42; break;
        case SDLK_u: KEYTBL[7]|=0x03; break;
        case SDLK_j: KEYTBL[7]|=0x24; break;
        case SDLK_m: KEYTBL[7]|=0x48; break;
        case SDLK_7: KEYTBL[7]|=0x06; break;
        case SDLK_y: KEYTBL[7]|=0x05; break;
        case SDLK_h: KEYTBL[7]|=0x44; break;
        case SDLK_n: KEYTBL[7]|=0x50; break;
        case SDLK_RETURN: KEYTBL[7]|=0x09; break;
        case SDLK_SPACE: KEYTBL[11]|=0x0c; break;

        case SDLK_LCTRL:  KEYTBL[7]|=0x80; break;
        case SDLK_LSHIFT: KEYTBL[13]|=0x80; break;
        case SDLK_RSHIFT: KEYTBL[14]|=0x80; break;
        case SDLK_TAB: KEYTBL[11]|=0x80; break;

        case SDLK_DOWN:   KEYTBL[14]|=0x02;break;
        case SDLK_UP:     KEYTBL[14]|=0x08;break;
        case SDLK_LEFT:   KEYTBL[14]|=0x20;break;
        case SDLK_RIGHT:  KEYTBL[14]|=0x04;break;

      }
    }

    if (sdl_event.type == SDL_QUIT) {
       ExitNow=1;
    }

	if (sdl_event.type == SDL_JOYHATMOTION) {
		if ( sdl_event.jhat.value & SDL_HAT_LEFT )
			KEYTBL[14]=0xdf;
			else if ( sdl_event.jhat.value & SDL_HAT_RIGHT )
			KEYTBL[14]=0xfb;
			else if ( sdl_event.jhat.value & SDL_HAT_UP )
			KEYTBL[14]=0xf7;
			else if ( sdl_event.jhat.value & SDL_HAT_DOWN )
			KEYTBL[14]=0xfd;
		else
		{
			KEYTBL[14]|=0x20;
			KEYTBL[14]|=0x04;
			KEYTBL[14]|=0x02;
			KEYTBL[14]|=0x08;
		}

	}

	if (sdl_event.type == SDL_JOYBUTTONDOWN) {
		switch (sdl_event.jbutton.which) {
			case 0:							/* Wiimote */
				if(sdl_event.jbutton.button==0)		/* Wiimote 1 Button A */
					Reset6502(&CPU);
				else if(sdl_event.jbutton.button==1)	/* Wiimote 1 Button B */
					KEYTBL[13]&=0xde; //S
				else if(sdl_event.jbutton.button==2)	/* Wiimote 1 Button 1 */
					KEYTBL[13]&=0x7f; //Lshift
				else if(sdl_event.jbutton.button==3)	/* Wiimote 1 Button 1 */
					KEYTBL[14]&=0x7f; //Lshift
				else if(sdl_event.jbutton.button==6)	/* Wiimote 1 Button Home */
				{
					ExitNow=1;
					break;
				}
		break;
		}		
	}

	if (sdl_event.type == SDL_JOYBUTTONUP) {
		switch (sdl_event.jbutton.which) {
				case 0:							/* Wiimote */
					//if(sdl_event.jbutton.button==0)
					//	Reset6502(&CPU);
					if(sdl_event.jbutton.button==1)
						KEYTBL[13]|=0x21; //S
					else if(sdl_event.jbutton.button==2)
						KEYTBL[13]|=0x80; //Lshift
					else if(sdl_event.jbutton.button==3)
						KEYTBL[14]|=0x80; //Lshift
				break;
			}		
	}
  }
}

#include "Common.h"

